<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Dice Roll generator and analyzer</title>
</head>
<body>
<?php
	/*
Copyright (c) 2006 Blazing Games Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in 
the Software without restriction, including without limitation the rights to 
use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
SOFTWARE.	
	*/
	$diceList = array(2,3,4,5,6,8,10,12,20,30,100);
	$diceToRoll = 3;
	$diceSides = 6;
	$diceModifier = 0;
	$showResults = array_key_exists("show", $HTTP_GET_VARS);
	$showStats = array_key_exists("stats", $HTTP_GET_VARS);
	if (array_key_exists("d", $HTTP_GET_VARS))	
		$diceToRoll = max(1,min(20,$HTTP_GET_VARS["d"]));
	if (array_key_exists("s", $HTTP_GET_VARS))
		$diceSides = max(2,min(100, $HTTP_GET_VARS["s"]));
	if (array_key_exists("m", $HTTP_GET_VARS))	
		$diceModifier = $HTTP_GET_VARS["m"];

?>
<form action="PHPDice.php" method="get" name="form1" target="_self" id="form1">
  <label>
  <select name="d" size="1" id="d">
<?php
	for ($cntr = 1; $cntr < 21; ++$cntr) {
		if ($cntr == $diceToRoll)
			echo("<option selected=\"selected\">$cntr</option>");
		else
			echo("<option>$cntr</option>");
	}
?>
  </select>
  Number of dice to roll
  </label>
  <p>
    <label>
    <select name="s" size="1">
<?php
	foreach ($diceList as $cntr) {
		if ($cntr == $diceSides)
			echo("<option selected=\"selected\">$cntr</option>");
		else
			echo("<option>$cntr</option>");
	}
?>
    </select>
	Sides per die
    </label>
  </p>
  <p>
    <label>
    <select name="m" size="1">
<?php
	for ($cntr = -10; $cntr < 11; ++$cntr) {
		if ($cntr == $diceModifier)
			echo("<option selected=\"selected\">$cntr</option>");
		else
			echo("<option>$cntr</option>");
	}
?>
    </select>
	Adjustment after roll
    </label>
  </p>
  <p>
    <label>
<?php
	if ($showResults)
		echo "<input type=\"checkbox\" name=\"show\" value=\"true\" checked=\"checked\" />";
	else
		echo "<input type=\"checkbox\" name=\"show\" value=\"true\" />";
?>
    Show Result Table</label>
  </p>
  <p>
    <label>
<?php
	if ($showStats)
		echo "<input type=\"checkbox\" name=\"stats\" value=\"true\" checked=\"checked\" />";
	else
		echo "<input type=\"checkbox\" name=\"stats\" value=\"true\" />";
?>
    Show Roll Breakdown (stats)</label>
  </p>
  <p>
    <input type="submit" value="Roll the dice" />
  </p>
</form>
<p>Last roll type:
<?php
echo "${diceToRoll}D$diceSides";
	if ($diceModifier < 0)
		echo $diceModifier;
	else if ($diceModifier > 0)
		echo "+$diceModifier";
?>
</p>
<p>Roll results: 
<?php
	$roll = 0; 
	if ($showResults) {
		echo "<table border=\"1\">";
		echo "<tr><th>ROLL</th><th>Result of roll</th></tr>";
	}
	for ($cntr = 0; $cntr < $diceToRoll; ++$cntr) {
		$dieRoll = rand(1, $diceSides);
		$roll += $dieRoll;
		$index = $cntr+1;
		if ($showResults)
			echo "<tr><td>$index</td><td>$dieRoll</td></tr>";
	}
	$roll+=$diceModifier;
	if ($showResults)
		echo "</table>";
	echo "Roll was: $roll";
	
	if ($showStats) {
		$dieTable = array_fill(0,$diceToRoll+1, 1);
		$dieResults = array_fill(1, $diceToRoll*$diceSides, 0);
		$dieCombos = 0;
		do {
			// increase die
			$dieIndex = 0;
			$passDone = false;
			while (!$passDone) {
				++$dieTable[$dieIndex];
				if ($dieTable[$dieIndex] > $diceSides) {
					$dieTable[$dieIndex] = 1;
					++$dieIndex;
				} else
					$passDone = true;
			}
		
			// now calculate roll
			$roll = 0;
			for ($cntr = 0; $cntr < $diceToRoll; ++$cntr) {
				$roll += $dieTable[$cntr];
			}
			++$dieResults[$roll];
			++$dieCombos;
		} while ($dieTable[$diceToRoll] == 1);
		echo "</p><p>Statistics for roll";
		echo "<table border=\"1\">";
		echo "<tr><th>Result</th><th>Times occurred</th><th>Percent</th></tr>";
		for ($cntr = $diceToRoll; $cntr <= $diceToRoll*$diceSides; ++$cntr) {
			$diePct = round($dieResults[$cntr] / $dieCombos * 100, 4);
			$modifiedResult = $cntr + $diceModifier;
			echo "<tr><td>$modifiedResult</td><td>$dieResults[$cntr]</td><td>$diePct</td></tr>";
		}
	}
?>
</p>
<p>Copyright &copy; 2006 Blazing Games Inc.</p>
</body>
</html>

